# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_denm_msgs/StationaryVehicleContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_denm_msgs.msg

class StationaryVehicleContainer(genpy.Message):
  _md5sum = "e4097d00599a1b63a3fa0c3174f19312"
  _type = "etsi_its_denm_msgs/StationaryVehicleContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StationaryVehicleContainer ::= SEQUENCE {
# 	stationarySince StationarySince OPTIONAL,
# 	stationaryCause CauseCode OPTIONAL,
# 	carryingDangerousGoods DangerousGoodsExtended OPTIONAL,
# 	numberOfOccupants NumberOfOccupants OPTIONAL,
# 	vehicleIdentification VehicleIdentification OPTIONAL,
# 	energyStorageType EnergyStorageType OPTIONAL
# }
# ------------------------------------------------------------------------------

StationarySince stationary_since
bool stationary_since_is_present

CauseCode stationary_cause
bool stationary_cause_is_present

DangerousGoodsExtended carrying_dangerous_goods
bool carrying_dangerous_goods_is_present

NumberOfOccupants number_of_occupants
bool number_of_occupants_is_present

VehicleIdentification vehicle_identification
bool vehicle_identification_is_present

EnergyStorageType energy_storage_type
bool energy_storage_type_is_present


================================================================================
MSG: etsi_its_denm_msgs/StationarySince
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# StationarySince ::= ENUMERATED {lessThan1Minute(0), lessThan2Minutes(1), lessThan15Minutes(2), equalOrGreater15Minutes(3)}
# ------------------------------------------------------------------------------

uint8 value
uint8 LESS_THAN1_MINUTE = 0
uint8 LESS_THAN2_MINUTES = 1
uint8 LESS_THAN15_MINUTES = 2
uint8 EQUAL_OR_GREATER15_MINUTES = 3


================================================================================
MSG: etsi_its_denm_msgs/CauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CauseCode ::= SEQUENCE {
#     causeCode CauseCodeType,
#     subCauseCode SubCauseCodeType,
#         ...
# }
# ------------------------------------------------------------------------------

CauseCodeType cause_code

SubCauseCodeType sub_cause_code


================================================================================
MSG: etsi_its_denm_msgs/CauseCodeType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# CauseCodeType ::= INTEGER {
#     reserved (0),
#     trafficCondition (1),
#     accident (2),
#     roadworks (3),
#         impassability (5),
#     adverseWeatherCondition-Adhesion (6),
#         aquaplannning (7),
#     hazardousLocation-SurfaceCondition (9),
#     hazardousLocation-ObstacleOnTheRoad (10),
#     hazardousLocation-AnimalOnTheRoad (11),
#     humanPresenceOnTheRoad (12),
#     wrongWayDriving (14),
#     rescueAndRecoveryWorkInProgress (15),
#     adverseWeatherCondition-ExtremeWeatherCondition (17),
#     adverseWeatherCondition-Visibility (18),
#     adverseWeatherCondition-Precipitation (19),
#     slowVehicle (26),
#     dangerousEndOfQueue (27),
#     vehicleBreakdown (91),
#     postCrash (92),
#     humanProblem (93),
#     stationaryVehicle (94),
#     emergencyVehicleApproaching (95),
#     hazardousLocation-DangerousCurve (96),
#     collisionRisk (97),
#     signalViolation (98),
#     dangerousSituation (99)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 RESERVED = 0
uint8 TRAFFIC_CONDITION = 1
uint8 ACCIDENT = 2
uint8 ROADWORKS = 3
uint8 IMPASSABILITY = 5
uint8 ADVERSE_WEATHER_CONDITION_ADHESION = 6
uint8 AQUAPLANNNING = 7
uint8 HAZARDOUS_LOCATION_SURFACE_CONDITION = 9
uint8 HAZARDOUS_LOCATION_OBSTACLE_ON_THE_ROAD = 10
uint8 HAZARDOUS_LOCATION_ANIMAL_ON_THE_ROAD = 11
uint8 HUMAN_PRESENCE_ON_THE_ROAD = 12
uint8 WRONG_WAY_DRIVING = 14
uint8 RESCUE_AND_RECOVERY_WORK_IN_PROGRESS = 15
uint8 ADVERSE_WEATHER_CONDITION_EXTREME_WEATHER_CONDITION = 17
uint8 ADVERSE_WEATHER_CONDITION_VISIBILITY = 18
uint8 ADVERSE_WEATHER_CONDITION_PRECIPITATION = 19
uint8 SLOW_VEHICLE = 26
uint8 DANGEROUS_END_OF_QUEUE = 27
uint8 VEHICLE_BREAKDOWN = 91
uint8 POST_CRASH = 92
uint8 HUMAN_PROBLEM = 93
uint8 STATIONARY_VEHICLE = 94
uint8 EMERGENCY_VEHICLE_APPROACHING = 95
uint8 HAZARDOUS_LOCATION_DANGEROUS_CURVE = 96
uint8 COLLISION_RISK = 97
uint8 SIGNAL_VIOLATION = 98
uint8 DANGEROUS_SITUATION = 99


================================================================================
MSG: etsi_its_denm_msgs/SubCauseCodeType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# SubCauseCodeType ::= INTEGER (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255


================================================================================
MSG: etsi_its_denm_msgs/DangerousGoodsExtended
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DangerousGoodsExtended ::= SEQUENCE {
#     dangerousGoodsType DangerousGoodsBasic,
#     unNumber INTEGER (0..9999),
#     elevatedTemperature BOOLEAN,
#     tunnelsRestricted BOOLEAN,
#     limitedQuantity BOOLEAN,
#     emergencyActionCode IA5String (SIZE (1..24)) OPTIONAL,
#     phoneNumber PhoneNumber OPTIONAL,
#     companyName UTF8String (SIZE (1..24)) OPTIONAL,
#         ...
# }
# ------------------------------------------------------------------------------

DangerousGoodsBasic dangerous_goods_type

uint16 un_number
uint16 UN_NUMBER_MIN = 0
uint16 UN_NUMBER_MAX = 9999

bool elevated_temperature

bool tunnels_restricted

bool limited_quantity

string emergency_action_code
bool emergency_action_code_is_present
uint8 EMERGENCY_ACTION_CODE_MIN_SIZE = 1
uint8 EMERGENCY_ACTION_CODE_MAX_SIZE = 24

PhoneNumber phone_number
bool phone_number_is_present

string company_name
bool company_name_is_present
uint8 COMPANY_NAME_MIN_SIZE = 1
uint8 COMPANY_NAME_MAX_SIZE = 24


================================================================================
MSG: etsi_its_denm_msgs/DangerousGoodsBasic
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# DangerousGoodsBasic::= ENUMERATED {
#     explosives1(0),
#     explosives2(1),
#     explosives3(2),
#     explosives4(3),
#     explosives5(4),
#     explosives6(5),
#     flammableGases(6),
#     nonFlammableGases(7),
#     toxicGases(8),
#     flammableLiquids(9),
#     flammableSolids(10),
#     substancesLiableToSpontaneousCombustion(11),
#     substancesEmittingFlammableGasesUponContactWithWater(12),
#     oxidizingSubstances(13),
#     organicPeroxides(14),
#     toxicSubstances(15),
#     infectiousSubstances(16),
#     radioactiveMaterial(17),
#     corrosiveSubstances(18),
#     miscellaneousDangerousSubstances(19)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 EXPLOSIVES1 = 0
uint8 EXPLOSIVES2 = 1
uint8 EXPLOSIVES3 = 2
uint8 EXPLOSIVES4 = 3
uint8 EXPLOSIVES5 = 4
uint8 EXPLOSIVES6 = 5
uint8 FLAMMABLE_GASES = 6
uint8 NON_FLAMMABLE_GASES = 7
uint8 TOXIC_GASES = 8
uint8 FLAMMABLE_LIQUIDS = 9
uint8 FLAMMABLE_SOLIDS = 10
uint8 SUBSTANCES_LIABLE_TO_SPONTANEOUS_COMBUSTION = 11
uint8 SUBSTANCES_EMITTING_FLAMMABLE_GASES_UPON_CONTACT_WITH_WATER = 12
uint8 OXIDIZING_SUBSTANCES = 13
uint8 ORGANIC_PEROXIDES = 14
uint8 TOXIC_SUBSTANCES = 15
uint8 INFECTIOUS_SUBSTANCES = 16
uint8 RADIOACTIVE_MATERIAL = 17
uint8 CORROSIVE_SUBSTANCES = 18
uint8 MISCELLANEOUS_DANGEROUS_SUBSTANCES = 19


================================================================================
MSG: etsi_its_denm_msgs/PhoneNumber
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# PhoneNumber ::= NumericString (SIZE(1..16))
# ------------------------------------------------------------------------------

string value
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 16


================================================================================
MSG: etsi_its_denm_msgs/NumberOfOccupants
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# NumberOfOccupants ::= INTEGER {oneOccupant (1), unavailable(127)} (0 .. 127)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 127
uint8 ONE_OCCUPANT = 1
uint8 UNAVAILABLE = 127


================================================================================
MSG: etsi_its_denm_msgs/VehicleIdentification
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VehicleIdentification ::= SEQUENCE {
#     wMInumber WMInumber OPTIONAL,
#     vDS VDS OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

WMInumber w_m_inumber
bool w_m_inumber_is_present

VDS v_ds
bool v_ds_is_present


================================================================================
MSG: etsi_its_denm_msgs/WMInumber
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# WMInumber ::= IA5String (SIZE(1..3))
# ------------------------------------------------------------------------------

string value
uint8 MIN_SIZE = 1
uint8 MAX_SIZE = 3


================================================================================
MSG: etsi_its_denm_msgs/VDS
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# VDS ::= IA5String (SIZE(6))
# ------------------------------------------------------------------------------

string value
uint8 SIZE = 6


================================================================================
MSG: etsi_its_denm_msgs/EnergyStorageType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/denm_en302637_3/DENM-PDU-Descriptions.asn
#   asn1/raw/denm_en302637_3/cdd/ITS-Container.asn
#   -t
#   denm
#   -o
#   etsi_its_msgs/etsi_its_denm_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# EnergyStorageType ::= BIT STRING {hydrogenStorage(0), electricEnergyStorage(1), liquidPropaneGas(2), compressedNaturalGas(3), diesel(4), gasoline(5), ammonia(6)} (SIZE(7))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 7
uint8 BIT_INDEX_HYDROGEN_STORAGE = 0
uint8 BIT_INDEX_ELECTRIC_ENERGY_STORAGE = 1
uint8 BIT_INDEX_LIQUID_PROPANE_GAS = 2
uint8 BIT_INDEX_COMPRESSED_NATURAL_GAS = 3
uint8 BIT_INDEX_DIESEL = 4
uint8 BIT_INDEX_GASOLINE = 5
uint8 BIT_INDEX_AMMONIA = 6

"""
  __slots__ = ['stationary_since','stationary_since_is_present','stationary_cause','stationary_cause_is_present','carrying_dangerous_goods','carrying_dangerous_goods_is_present','number_of_occupants','number_of_occupants_is_present','vehicle_identification','vehicle_identification_is_present','energy_storage_type','energy_storage_type_is_present']
  _slot_types = ['etsi_its_denm_msgs/StationarySince','bool','etsi_its_denm_msgs/CauseCode','bool','etsi_its_denm_msgs/DangerousGoodsExtended','bool','etsi_its_denm_msgs/NumberOfOccupants','bool','etsi_its_denm_msgs/VehicleIdentification','bool','etsi_its_denm_msgs/EnergyStorageType','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stationary_since,stationary_since_is_present,stationary_cause,stationary_cause_is_present,carrying_dangerous_goods,carrying_dangerous_goods_is_present,number_of_occupants,number_of_occupants_is_present,vehicle_identification,vehicle_identification_is_present,energy_storage_type,energy_storage_type_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StationaryVehicleContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stationary_since is None:
        self.stationary_since = etsi_its_denm_msgs.msg.StationarySince()
      if self.stationary_since_is_present is None:
        self.stationary_since_is_present = False
      if self.stationary_cause is None:
        self.stationary_cause = etsi_its_denm_msgs.msg.CauseCode()
      if self.stationary_cause_is_present is None:
        self.stationary_cause_is_present = False
      if self.carrying_dangerous_goods is None:
        self.carrying_dangerous_goods = etsi_its_denm_msgs.msg.DangerousGoodsExtended()
      if self.carrying_dangerous_goods_is_present is None:
        self.carrying_dangerous_goods_is_present = False
      if self.number_of_occupants is None:
        self.number_of_occupants = etsi_its_denm_msgs.msg.NumberOfOccupants()
      if self.number_of_occupants_is_present is None:
        self.number_of_occupants_is_present = False
      if self.vehicle_identification is None:
        self.vehicle_identification = etsi_its_denm_msgs.msg.VehicleIdentification()
      if self.vehicle_identification_is_present is None:
        self.vehicle_identification_is_present = False
      if self.energy_storage_type is None:
        self.energy_storage_type = etsi_its_denm_msgs.msg.EnergyStorageType()
      if self.energy_storage_type_is_present is None:
        self.energy_storage_type_is_present = False
    else:
      self.stationary_since = etsi_its_denm_msgs.msg.StationarySince()
      self.stationary_since_is_present = False
      self.stationary_cause = etsi_its_denm_msgs.msg.CauseCode()
      self.stationary_cause_is_present = False
      self.carrying_dangerous_goods = etsi_its_denm_msgs.msg.DangerousGoodsExtended()
      self.carrying_dangerous_goods_is_present = False
      self.number_of_occupants = etsi_its_denm_msgs.msg.NumberOfOccupants()
      self.number_of_occupants_is_present = False
      self.vehicle_identification = etsi_its_denm_msgs.msg.VehicleIdentification()
      self.vehicle_identification_is_present = False
      self.energy_storage_type = etsi_its_denm_msgs.msg.EnergyStorageType()
      self.energy_storage_type_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_6BH3B().pack(_x.stationary_since.value, _x.stationary_since_is_present, _x.stationary_cause.cause_code.value, _x.stationary_cause.sub_cause_code.value, _x.stationary_cause_is_present, _x.carrying_dangerous_goods.dangerous_goods_type.value, _x.carrying_dangerous_goods.un_number, _x.carrying_dangerous_goods.elevated_temperature, _x.carrying_dangerous_goods.tunnels_restricted, _x.carrying_dangerous_goods.limited_quantity))
      _x = self.carrying_dangerous_goods.emergency_action_code
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.carrying_dangerous_goods.emergency_action_code_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.carrying_dangerous_goods.phone_number.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.carrying_dangerous_goods.phone_number_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.carrying_dangerous_goods.company_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.carrying_dangerous_goods.company_name_is_present, _x.carrying_dangerous_goods_is_present, _x.number_of_occupants.value, _x.number_of_occupants_is_present))
      _x = self.vehicle_identification.w_m_inumber.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicle_identification.w_m_inumber_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.vehicle_identification.v_ds.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.vehicle_identification.v_ds_is_present, _x.vehicle_identification_is_present))
      _x = self.energy_storage_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.energy_storage_type.bits_unused, _x.energy_storage_type_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stationary_since is None:
        self.stationary_since = etsi_its_denm_msgs.msg.StationarySince()
      if self.stationary_cause is None:
        self.stationary_cause = etsi_its_denm_msgs.msg.CauseCode()
      if self.carrying_dangerous_goods is None:
        self.carrying_dangerous_goods = etsi_its_denm_msgs.msg.DangerousGoodsExtended()
      if self.number_of_occupants is None:
        self.number_of_occupants = etsi_its_denm_msgs.msg.NumberOfOccupants()
      if self.vehicle_identification is None:
        self.vehicle_identification = etsi_its_denm_msgs.msg.VehicleIdentification()
      if self.energy_storage_type is None:
        self.energy_storage_type = etsi_its_denm_msgs.msg.EnergyStorageType()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stationary_since.value, _x.stationary_since_is_present, _x.stationary_cause.cause_code.value, _x.stationary_cause.sub_cause_code.value, _x.stationary_cause_is_present, _x.carrying_dangerous_goods.dangerous_goods_type.value, _x.carrying_dangerous_goods.un_number, _x.carrying_dangerous_goods.elevated_temperature, _x.carrying_dangerous_goods.tunnels_restricted, _x.carrying_dangerous_goods.limited_quantity,) = _get_struct_6BH3B().unpack(str[start:end])
      self.stationary_since_is_present = bool(self.stationary_since_is_present)
      self.stationary_cause_is_present = bool(self.stationary_cause_is_present)
      self.carrying_dangerous_goods.elevated_temperature = bool(self.carrying_dangerous_goods.elevated_temperature)
      self.carrying_dangerous_goods.tunnels_restricted = bool(self.carrying_dangerous_goods.tunnels_restricted)
      self.carrying_dangerous_goods.limited_quantity = bool(self.carrying_dangerous_goods.limited_quantity)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.emergency_action_code = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.emergency_action_code = str[start:end]
      start = end
      end += 1
      (self.carrying_dangerous_goods.emergency_action_code_is_present,) = _get_struct_B().unpack(str[start:end])
      self.carrying_dangerous_goods.emergency_action_code_is_present = bool(self.carrying_dangerous_goods.emergency_action_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.phone_number.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.phone_number.value = str[start:end]
      start = end
      end += 1
      (self.carrying_dangerous_goods.phone_number_is_present,) = _get_struct_B().unpack(str[start:end])
      self.carrying_dangerous_goods.phone_number_is_present = bool(self.carrying_dangerous_goods.phone_number_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.company_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.company_name = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.carrying_dangerous_goods.company_name_is_present, _x.carrying_dangerous_goods_is_present, _x.number_of_occupants.value, _x.number_of_occupants_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.carrying_dangerous_goods.company_name_is_present = bool(self.carrying_dangerous_goods.company_name_is_present)
      self.carrying_dangerous_goods_is_present = bool(self.carrying_dangerous_goods_is_present)
      self.number_of_occupants_is_present = bool(self.number_of_occupants_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_identification.w_m_inumber.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_identification.w_m_inumber.value = str[start:end]
      start = end
      end += 1
      (self.vehicle_identification.w_m_inumber_is_present,) = _get_struct_B().unpack(str[start:end])
      self.vehicle_identification.w_m_inumber_is_present = bool(self.vehicle_identification.w_m_inumber_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_identification.v_ds.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_identification.v_ds.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.vehicle_identification.v_ds_is_present, _x.vehicle_identification_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.vehicle_identification.v_ds_is_present = bool(self.vehicle_identification.v_ds_is_present)
      self.vehicle_identification_is_present = bool(self.vehicle_identification_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.energy_storage_type.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.energy_storage_type.bits_unused, _x.energy_storage_type_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.energy_storage_type_is_present = bool(self.energy_storage_type_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_6BH3B().pack(_x.stationary_since.value, _x.stationary_since_is_present, _x.stationary_cause.cause_code.value, _x.stationary_cause.sub_cause_code.value, _x.stationary_cause_is_present, _x.carrying_dangerous_goods.dangerous_goods_type.value, _x.carrying_dangerous_goods.un_number, _x.carrying_dangerous_goods.elevated_temperature, _x.carrying_dangerous_goods.tunnels_restricted, _x.carrying_dangerous_goods.limited_quantity))
      _x = self.carrying_dangerous_goods.emergency_action_code
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.carrying_dangerous_goods.emergency_action_code_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.carrying_dangerous_goods.phone_number.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.carrying_dangerous_goods.phone_number_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.carrying_dangerous_goods.company_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4B().pack(_x.carrying_dangerous_goods.company_name_is_present, _x.carrying_dangerous_goods_is_present, _x.number_of_occupants.value, _x.number_of_occupants_is_present))
      _x = self.vehicle_identification.w_m_inumber.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.vehicle_identification.w_m_inumber_is_present
      buff.write(_get_struct_B().pack(_x))
      _x = self.vehicle_identification.v_ds.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.vehicle_identification.v_ds_is_present, _x.vehicle_identification_is_present))
      _x = self.energy_storage_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B().pack(_x.energy_storage_type.bits_unused, _x.energy_storage_type_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stationary_since is None:
        self.stationary_since = etsi_its_denm_msgs.msg.StationarySince()
      if self.stationary_cause is None:
        self.stationary_cause = etsi_its_denm_msgs.msg.CauseCode()
      if self.carrying_dangerous_goods is None:
        self.carrying_dangerous_goods = etsi_its_denm_msgs.msg.DangerousGoodsExtended()
      if self.number_of_occupants is None:
        self.number_of_occupants = etsi_its_denm_msgs.msg.NumberOfOccupants()
      if self.vehicle_identification is None:
        self.vehicle_identification = etsi_its_denm_msgs.msg.VehicleIdentification()
      if self.energy_storage_type is None:
        self.energy_storage_type = etsi_its_denm_msgs.msg.EnergyStorageType()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stationary_since.value, _x.stationary_since_is_present, _x.stationary_cause.cause_code.value, _x.stationary_cause.sub_cause_code.value, _x.stationary_cause_is_present, _x.carrying_dangerous_goods.dangerous_goods_type.value, _x.carrying_dangerous_goods.un_number, _x.carrying_dangerous_goods.elevated_temperature, _x.carrying_dangerous_goods.tunnels_restricted, _x.carrying_dangerous_goods.limited_quantity,) = _get_struct_6BH3B().unpack(str[start:end])
      self.stationary_since_is_present = bool(self.stationary_since_is_present)
      self.stationary_cause_is_present = bool(self.stationary_cause_is_present)
      self.carrying_dangerous_goods.elevated_temperature = bool(self.carrying_dangerous_goods.elevated_temperature)
      self.carrying_dangerous_goods.tunnels_restricted = bool(self.carrying_dangerous_goods.tunnels_restricted)
      self.carrying_dangerous_goods.limited_quantity = bool(self.carrying_dangerous_goods.limited_quantity)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.emergency_action_code = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.emergency_action_code = str[start:end]
      start = end
      end += 1
      (self.carrying_dangerous_goods.emergency_action_code_is_present,) = _get_struct_B().unpack(str[start:end])
      self.carrying_dangerous_goods.emergency_action_code_is_present = bool(self.carrying_dangerous_goods.emergency_action_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.phone_number.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.phone_number.value = str[start:end]
      start = end
      end += 1
      (self.carrying_dangerous_goods.phone_number_is_present,) = _get_struct_B().unpack(str[start:end])
      self.carrying_dangerous_goods.phone_number_is_present = bool(self.carrying_dangerous_goods.phone_number_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.carrying_dangerous_goods.company_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.carrying_dangerous_goods.company_name = str[start:end]
      _x = self
      start = end
      end += 4
      (_x.carrying_dangerous_goods.company_name_is_present, _x.carrying_dangerous_goods_is_present, _x.number_of_occupants.value, _x.number_of_occupants_is_present,) = _get_struct_4B().unpack(str[start:end])
      self.carrying_dangerous_goods.company_name_is_present = bool(self.carrying_dangerous_goods.company_name_is_present)
      self.carrying_dangerous_goods_is_present = bool(self.carrying_dangerous_goods_is_present)
      self.number_of_occupants_is_present = bool(self.number_of_occupants_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_identification.w_m_inumber.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_identification.w_m_inumber.value = str[start:end]
      start = end
      end += 1
      (self.vehicle_identification.w_m_inumber_is_present,) = _get_struct_B().unpack(str[start:end])
      self.vehicle_identification.w_m_inumber_is_present = bool(self.vehicle_identification.w_m_inumber_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.vehicle_identification.v_ds.value = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.vehicle_identification.v_ds.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.vehicle_identification.v_ds_is_present, _x.vehicle_identification_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.vehicle_identification.v_ds_is_present = bool(self.vehicle_identification.v_ds_is_present)
      self.vehicle_identification_is_present = bool(self.vehicle_identification_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.energy_storage_type.value = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.energy_storage_type.bits_unused, _x.energy_storage_type_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.energy_storage_type_is_present = bool(self.energy_storage_type_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_6BH3B = None
def _get_struct_6BH3B():
    global _struct_6BH3B
    if _struct_6BH3B is None:
        _struct_6BH3B = struct.Struct("<6BH3B")
    return _struct_6BH3B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
