
"use strict";

let HumanPresenceOnTheRoadSubCauseCode = require('./HumanPresenceOnTheRoadSubCauseCode.js');
let PathHistory = require('./PathHistory.js');
let Temperature = require('./Temperature.js');
let PosPillar = require('./PosPillar.js');
let ImpactReductionContainer = require('./ImpactReductionContainer.js');
let EmergencyVehicleApproachingSubCauseCode = require('./EmergencyVehicleApproachingSubCauseCode.js');
let RequestResponseIndication = require('./RequestResponseIndication.js');
let DeltaLongitude = require('./DeltaLongitude.js');
let ClosedLanes = require('./ClosedLanes.js');
let SpeedValue = require('./SpeedValue.js');
let WheelBaseVehicle = require('./WheelBaseVehicle.js');
let Traces = require('./Traces.js');
let PathDeltaTime = require('./PathDeltaTime.js');
let RoadworksSubCauseCode = require('./RoadworksSubCauseCode.js');
let VehicleIdentification = require('./VehicleIdentification.js');
let ItsPduHeader = require('./ItsPduHeader.js');
let ReferencePosition = require('./ReferencePosition.js');
let Altitude = require('./Altitude.js');
let PosLonCarr = require('./PosLonCarr.js');
let RescueAndRecoveryWorkInProgressSubCauseCode = require('./RescueAndRecoveryWorkInProgressSubCauseCode.js');
let Heading = require('./Heading.js');
let PhoneNumber = require('./PhoneNumber.js');
let SemiAxisLength = require('./SemiAxisLength.js');
let DangerousGoodsExtended = require('./DangerousGoodsExtended.js');
let AccidentSubCauseCode = require('./AccidentSubCauseCode.js');
let SlowVehicleSubCauseCode = require('./SlowVehicleSubCauseCode.js');
let PositionOfPillars = require('./PositionOfPillars.js');
let HazardousLocationObstacleOnTheRoadSubCauseCode = require('./HazardousLocationObstacleOnTheRoadSubCauseCode.js');
let PathPoint = require('./PathPoint.js');
let TurningRadius = require('./TurningRadius.js');
let DeltaAltitude = require('./DeltaAltitude.js');
let TrafficConditionSubCauseCode = require('./TrafficConditionSubCauseCode.js');
let PosFrontAx = require('./PosFrontAx.js');
let NumberOfOccupants = require('./NumberOfOccupants.js');
let HumanProblemSubCauseCode = require('./HumanProblemSubCauseCode.js');
let DecentralizedEnvironmentalNotificationMessage = require('./DecentralizedEnvironmentalNotificationMessage.js');
let AdverseWeatherConditionPrecipitationSubCauseCode = require('./AdverseWeatherConditionPrecipitationSubCauseCode.js');
let DangerousSituationSubCauseCode = require('./DangerousSituationSubCauseCode.js');
let ReferenceDenms = require('./ReferenceDenms.js');
let VehicleBreakdownSubCauseCode = require('./VehicleBreakdownSubCauseCode.js');
let AltitudeConfidence = require('./AltitudeConfidence.js');
let StationType = require('./StationType.js');
let StationID = require('./StationID.js');
let PositioningSolutionType = require('./PositioningSolutionType.js');
let TimestampIts = require('./TimestampIts.js');
let HazardousLocationDangerousCurveSubCauseCode = require('./HazardousLocationDangerousCurveSubCauseCode.js');
let ManagementContainer = require('./ManagementContainer.js');
let ItineraryPath = require('./ItineraryPath.js');
let TransmissionInterval = require('./TransmissionInterval.js');
let VehicleMass = require('./VehicleMass.js');
let AdverseWeatherConditionExtremeWeatherConditionSubCauseCode = require('./AdverseWeatherConditionExtremeWeatherConditionSubCauseCode.js');
let AltitudeValue = require('./AltitudeValue.js');
let LanePosition = require('./LanePosition.js');
let HazardousLocationSurfaceConditionSubCauseCode = require('./HazardousLocationSurfaceConditionSubCauseCode.js');
let CollisionRiskSubCauseCode = require('./CollisionRiskSubCauseCode.js');
let HeadingConfidence = require('./HeadingConfidence.js');
let RelevanceDistance = require('./RelevanceDistance.js');
let PostCrashSubCauseCode = require('./PostCrashSubCauseCode.js');
let DENM = require('./DENM.js');
let LightBarSirenInUse = require('./LightBarSirenInUse.js');
let WMInumber = require('./WMInumber.js');
let HazardousLocationAnimalOnTheRoadSubCauseCode = require('./HazardousLocationAnimalOnTheRoadSubCauseCode.js');
let DangerousGoodsBasic = require('./DangerousGoodsBasic.js');
let StationaryVehicleSubCauseCode = require('./StationaryVehicleSubCauseCode.js');
let HeadingValue = require('./HeadingValue.js');
let AlacarteContainer = require('./AlacarteContainer.js');
let EventPoint = require('./EventPoint.js');
let DrivingLaneStatus = require('./DrivingLaneStatus.js');
let SignalViolationSubCauseCode = require('./SignalViolationSubCauseCode.js');
let CauseCode = require('./CauseCode.js');
let CauseCodeType = require('./CauseCodeType.js');
let LocationContainer = require('./LocationContainer.js');
let RestrictedTypes = require('./RestrictedTypes.js');
let TrafficRule = require('./TrafficRule.js');
let RelevanceTrafficDirection = require('./RelevanceTrafficDirection.js');
let StationarySince = require('./StationarySince.js');
let SpeedConfidence = require('./SpeedConfidence.js');
let SubCauseCodeType = require('./SubCauseCodeType.js');
let AdverseWeatherConditionAdhesionSubCauseCode = require('./AdverseWeatherConditionAdhesionSubCauseCode.js');
let AdverseWeatherConditionVisibilitySubCauseCode = require('./AdverseWeatherConditionVisibilitySubCauseCode.js');
let WrongWayDrivingSubCauseCode = require('./WrongWayDrivingSubCauseCode.js');
let PosCentMass = require('./PosCentMass.js');
let HeightLonCarr = require('./HeightLonCarr.js');
let VDS = require('./VDS.js');
let Termination = require('./Termination.js');
let RoadWorksContainerExtended = require('./RoadWorksContainerExtended.js');
let ActionID = require('./ActionID.js');
let EventHistory = require('./EventHistory.js');
let SituationContainer = require('./SituationContainer.js');
let Latitude = require('./Latitude.js');
let SpeedLimit = require('./SpeedLimit.js');
let DeltaReferencePosition = require('./DeltaReferencePosition.js');
let Longitude = require('./Longitude.js');
let DeltaLatitude = require('./DeltaLatitude.js');
let RoadType = require('./RoadType.js');
let PosConfidenceEllipse = require('./PosConfidenceEllipse.js');
let HardShoulderStatus = require('./HardShoulderStatus.js');
let EnergyStorageType = require('./EnergyStorageType.js');
let Speed = require('./Speed.js');
let PositionOfOccupants = require('./PositionOfOccupants.js');
let DangerousEndOfQueueSubCauseCode = require('./DangerousEndOfQueueSubCauseCode.js');
let ValidityDuration = require('./ValidityDuration.js');
let StationaryVehicleContainer = require('./StationaryVehicleContainer.js');
let SequenceNumber = require('./SequenceNumber.js');
let InformationQuality = require('./InformationQuality.js');

module.exports = {
  HumanPresenceOnTheRoadSubCauseCode: HumanPresenceOnTheRoadSubCauseCode,
  PathHistory: PathHistory,
  Temperature: Temperature,
  PosPillar: PosPillar,
  ImpactReductionContainer: ImpactReductionContainer,
  EmergencyVehicleApproachingSubCauseCode: EmergencyVehicleApproachingSubCauseCode,
  RequestResponseIndication: RequestResponseIndication,
  DeltaLongitude: DeltaLongitude,
  ClosedLanes: ClosedLanes,
  SpeedValue: SpeedValue,
  WheelBaseVehicle: WheelBaseVehicle,
  Traces: Traces,
  PathDeltaTime: PathDeltaTime,
  RoadworksSubCauseCode: RoadworksSubCauseCode,
  VehicleIdentification: VehicleIdentification,
  ItsPduHeader: ItsPduHeader,
  ReferencePosition: ReferencePosition,
  Altitude: Altitude,
  PosLonCarr: PosLonCarr,
  RescueAndRecoveryWorkInProgressSubCauseCode: RescueAndRecoveryWorkInProgressSubCauseCode,
  Heading: Heading,
  PhoneNumber: PhoneNumber,
  SemiAxisLength: SemiAxisLength,
  DangerousGoodsExtended: DangerousGoodsExtended,
  AccidentSubCauseCode: AccidentSubCauseCode,
  SlowVehicleSubCauseCode: SlowVehicleSubCauseCode,
  PositionOfPillars: PositionOfPillars,
  HazardousLocationObstacleOnTheRoadSubCauseCode: HazardousLocationObstacleOnTheRoadSubCauseCode,
  PathPoint: PathPoint,
  TurningRadius: TurningRadius,
  DeltaAltitude: DeltaAltitude,
  TrafficConditionSubCauseCode: TrafficConditionSubCauseCode,
  PosFrontAx: PosFrontAx,
  NumberOfOccupants: NumberOfOccupants,
  HumanProblemSubCauseCode: HumanProblemSubCauseCode,
  DecentralizedEnvironmentalNotificationMessage: DecentralizedEnvironmentalNotificationMessage,
  AdverseWeatherConditionPrecipitationSubCauseCode: AdverseWeatherConditionPrecipitationSubCauseCode,
  DangerousSituationSubCauseCode: DangerousSituationSubCauseCode,
  ReferenceDenms: ReferenceDenms,
  VehicleBreakdownSubCauseCode: VehicleBreakdownSubCauseCode,
  AltitudeConfidence: AltitudeConfidence,
  StationType: StationType,
  StationID: StationID,
  PositioningSolutionType: PositioningSolutionType,
  TimestampIts: TimestampIts,
  HazardousLocationDangerousCurveSubCauseCode: HazardousLocationDangerousCurveSubCauseCode,
  ManagementContainer: ManagementContainer,
  ItineraryPath: ItineraryPath,
  TransmissionInterval: TransmissionInterval,
  VehicleMass: VehicleMass,
  AdverseWeatherConditionExtremeWeatherConditionSubCauseCode: AdverseWeatherConditionExtremeWeatherConditionSubCauseCode,
  AltitudeValue: AltitudeValue,
  LanePosition: LanePosition,
  HazardousLocationSurfaceConditionSubCauseCode: HazardousLocationSurfaceConditionSubCauseCode,
  CollisionRiskSubCauseCode: CollisionRiskSubCauseCode,
  HeadingConfidence: HeadingConfidence,
  RelevanceDistance: RelevanceDistance,
  PostCrashSubCauseCode: PostCrashSubCauseCode,
  DENM: DENM,
  LightBarSirenInUse: LightBarSirenInUse,
  WMInumber: WMInumber,
  HazardousLocationAnimalOnTheRoadSubCauseCode: HazardousLocationAnimalOnTheRoadSubCauseCode,
  DangerousGoodsBasic: DangerousGoodsBasic,
  StationaryVehicleSubCauseCode: StationaryVehicleSubCauseCode,
  HeadingValue: HeadingValue,
  AlacarteContainer: AlacarteContainer,
  EventPoint: EventPoint,
  DrivingLaneStatus: DrivingLaneStatus,
  SignalViolationSubCauseCode: SignalViolationSubCauseCode,
  CauseCode: CauseCode,
  CauseCodeType: CauseCodeType,
  LocationContainer: LocationContainer,
  RestrictedTypes: RestrictedTypes,
  TrafficRule: TrafficRule,
  RelevanceTrafficDirection: RelevanceTrafficDirection,
  StationarySince: StationarySince,
  SpeedConfidence: SpeedConfidence,
  SubCauseCodeType: SubCauseCodeType,
  AdverseWeatherConditionAdhesionSubCauseCode: AdverseWeatherConditionAdhesionSubCauseCode,
  AdverseWeatherConditionVisibilitySubCauseCode: AdverseWeatherConditionVisibilitySubCauseCode,
  WrongWayDrivingSubCauseCode: WrongWayDrivingSubCauseCode,
  PosCentMass: PosCentMass,
  HeightLonCarr: HeightLonCarr,
  VDS: VDS,
  Termination: Termination,
  RoadWorksContainerExtended: RoadWorksContainerExtended,
  ActionID: ActionID,
  EventHistory: EventHistory,
  SituationContainer: SituationContainer,
  Latitude: Latitude,
  SpeedLimit: SpeedLimit,
  DeltaReferencePosition: DeltaReferencePosition,
  Longitude: Longitude,
  DeltaLatitude: DeltaLatitude,
  RoadType: RoadType,
  PosConfidenceEllipse: PosConfidenceEllipse,
  HardShoulderStatus: HardShoulderStatus,
  EnergyStorageType: EnergyStorageType,
  Speed: Speed,
  PositionOfOccupants: PositionOfOccupants,
  DangerousEndOfQueueSubCauseCode: DangerousEndOfQueueSubCauseCode,
  ValidityDuration: ValidityDuration,
  StationaryVehicleContainer: StationaryVehicleContainer,
  SequenceNumber: SequenceNumber,
  InformationQuality: InformationQuality,
};
